<template>
    <ion-card color="secondary">
        <ion-card-header>
            <ion-card-title
                >{{ group.name }} ({{ group.id }})
                <div>
                    <ion-button
                        color="danger"
                        shape="round"
                        @click="$emit('removeClick', group.id)"
                        ><ion-icon slot="icon-only" :icon="close"></ion-icon
                    ></ion-button>
                    <ion-button
                        color="primary"
                        shape="round"
                        @click="$emit('editClick', group.id)"
                        ><ion-icon slot="icon-only" :icon="pencil"></ion-icon
                    ></ion-button>
                </div>
            </ion-card-title>
        </ion-card-header>

        <ion-card-content>
            <div>
                Aktivní:
                <ion-chip
                    ><ion-icon
                        v-if="group.isActive"
                        :icon="checkmark"
                        color="success" />
                    <ion-icon v-else :icon="close" color="danger"
                /></ion-chip>
            </div>
            <div>
                Vytvořeno:
                <ion-chip>{{ ymdhm(group.createdAt) }}</ion-chip>
            </div>
            <div v-if="group.updatedAt">
                Upraveno:
                <ion-chip>{{ ymdhm(group.updatedAt) }}</ion-chip>
            </div>
            <div v-if="appUser">
                Vlastník:
                <ion-chip>{{ appUser.name }} ({{ appUser.id }})</ion-chip>
            </div>
            <div v-if="group?.deviceList.length > 0">
                Zařízení:
                <ion-chip
                    v-for="device in group?.deviceList"
                    :key="device?.id"
                    >{{
                        [device.name, device.ip, device.mac]
                            .filter((v) => Boolean(v))
                            .join(', ')
                    }}</ion-chip
                >
            </div>
        </ion-card-content>
    </ion-card>
</template>

<script lang="ts" setup>
import { DeviceGroup, AppUser } from '@/gql/graphql'
import { ymdhm } from '@/helpers/dateFormat'
import {
    IonButton,
    IonChip,
    IonCard,
    IonCardContent,
    IonCardHeader,
    IonCardTitle,
    IonIcon,
} from '@ionic/vue'
import { checkmark, close, pencil } from 'ionicons/icons'

defineProps<{
    group: DeviceGroup
    appUser?: AppUser
}>()

defineEmits<{
    (e: 'editClick', id: string): void
    (e: 'removeClick', id: string): void
}>()
</script>
<style scoped>
ion-button {
    float: right;
}
</style>
